% case study: stoping rules
%
% Design : P. Nedoma
% Updated: October 2003
% Project: GA CR 102/03/0049, AV CR S1075351, S1075102, DESIGNER
prodini                                % startup routine
% build factor
str  = [1 1 2 2; 1 2 0 1];
Eth  = [1.81 -0.8187  0.00468  0.00438];
Fac  = facarxls(1,str);              % build 1st ARX simulation factor
Fac.Eth  = Eth;
Fac.cove = 0.01^2;

% generate data sample
ndat = 200;
DATA = [zeros(1, ndat); 0.01*randn(1,ndat)];
Sim  = mixconst(Fac, 1, 1);
mixsimul(Sim, ndat);

% build initial factor
Fac  = facarx(1, str);
echo off
% recursive factor estimation
for TIME = 3:ndat
   [Fac, Q] = stopstac(Fac);           % one step of estimation
  % store result
   Qs(TIME)  = Q;
   F         = arx2arx(Fac);
   a1s(TIME) = F.Eth(1);
   a2s(TIME) = F.Eth(2);
   b1s(TIME) = F.Eth(3);
   b2s(TIME) = F.Eth(4);
end

sub = 120;
LegendSize = 14;

sub=sub+1; subplot(sub); 
plot(DATA(2,:));
xlabel('time'); title(' ');
H = legend('Input'); 
set(H, 'fontSize', LegendSize); grid on
drawnow


sub=sub+1; subplot(sub); 
plot(DATA(1,:));
xlabel('time'); title(' ');
H = legend('Output'); 
set(H, 'fontSize', LegendSize); grid on
drawnow
plt('fig1')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
sub=120;
clf

sub=sub+1; subplot(sub);
plot(a1s); hold on ; plot(a2s,'--' );
hold on
plot([1 ndat], [1.81 1.81], ':');
plot([1 ndat], [-0.8187 -0.8187], ':');
%ax = axis; ax(3)=1.5; ax(4) = 2; axis(ax)
H=legend('a1','a2');
set(H, 'fontSize', LegendSize); 
xlabel('time');
drawnow

if 0
sub=sub+1; subplot(sub);
plot(b1s); hold on ; plot(b2s,'--');
plot([1 ndat], [0.00468 0.00468],':');
plot([1 ndat], [0.00438 0.00438],':');
H=legend('b1', 'b2');
ax = axis; ax(3)=-0.3; ax(4) = 0.3; axis(ax)
set(H, 'fontSize', LegendSize); 
xlabel('time');
drawnow
end

sub=sub+1; subplot(sub);
plot(Qs);
a=axis;
a(4) = 0.1; axis(a);
H=legend('Q');
set(H, 'fontSize', LegendSize); 
xlabel('time');
hold on
plot([1 ndat], [0.01 0.01], ':');
plot([1 ndat], [0.02 0.02], ':');
plot([1 ndat], [0.005 0.005], ':');
drawnow
plt('fig2')
