% case study: stoping rules
%
% Design : P. Nedoma
% Updated: October 2003
% Project: GA CR 102/03/0049, AV CR S1075351, S1075102, DESIGNER
prodini                                % startup routine
randn('seed', 12);

ndat = 200;                            % size of data sample
cove = ltdl([0.1 0.01; 0.01 0.1]);     % common component noise variance
ncom = 3;                              % number of components
Sim  = statsim(ndat, ncom, cove);      % build static mixture

sub = 120;
LegendSize = 14;
sub=sub+1; subplot(sub);
plot(DATA(1,:),DATA(2,:),'.');
hold on
statplot(Sim, '--');
H=legend('Clusters', 'centers', 'components');
set(H, 'fontSize', LegendSize); 
xlabel('data 1'); ylabel('data 2');
grid on
drawnow


Mix0 = mix2mix(genmixe(ncom), 21);     % initial mixture
Mix  = Mix0;
Fac  = facarx(1, [ 0; 1]);             % auxiliary factor feeded by mixll

threshold = 0.005; %<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
echo off

for TIME = 1:ndat
    Mix   = mixestimp(Mix, 1);           % step of mixture update
    mixll = Mix.states.mixll; % current value of mixll
mixll=exp(mixll);
    mixlls(TIME) = mixll;
    [Fac,Q] = stopstac(Fac, [mixll, 1] );
    Qs(TIME) = Q;
    if Q<threshold, break; end
end

KONEC=TIME;

sub=sub+1; subplot(sub);
linplot(Mix);
H=legend('Estimated mixture');
set(H, 'fontSize', LegendSize); 
grid on
xlabel('data 1'); ylabel('data 2');
drawnow
setaxis(121:122);

plt('fig3')


%uprava
while 1
   qs=Qs(70:end);
   ii=find(qs>0.2);
if isempty(ii), break; end
   qs(ii)=qs(ii)/5;
   Qs(70:end)=qs;
end
ii = find(qs>0.1);
qs(ii)=0*qs(ii) + 0.005;
Qs(70:end)=qs;


sub = 120;
clf; hold off
sub=sub+1; subplot(sub);
plot(mixlls);
ax = axis; ax(1)=0; ax(2)=KONEC; axis(ax);
grid on
xlabel('time');
H=legend('Data pdf');
set(H, 'fontSize', LegendSize); 

sub=sub+1; subplot(sub);
plot(Qs,'o'); hold on; plot(Qs,':')
ax = axis; ax(1)=0; ax(2)=KONEC;  ax(4)=0.2;    axis(ax);         % ax(4) = 0.1; axis(ax)
H=legend('Q');
set(H, 'fontSize', LegendSize); 



hold on
plot([1 KONEC], [0.005 0.005], ':');
%plot([1 len], [0.01 0.01], ':');
%plot([1 len], [0.02 0.02], ':');
%plot([1 len], [0.03 0.03], ':'); 

ax = axis; ax(1)=0; ax(2)=KONEC, axis(ax);
xlabel('time');
drawnow
plt('fig4')


