% case study: stoping rules
%
% Design : P. Nedoma
% Updated: October 2003
% Project: GA CR 102/03/0049, AV CR S1075351, S1075102, DESIGNER
prodini                                % startup routine
randn('seed', 19);

ndat = 200;                            % size of data sample
cove = ltdl([0.1 0.01; 0.01 0.1]);     % common component noise variance
ncom = 3;                              % number of components
Sim  = statsim(ndat, ncom, cove);      % build static mixture

sub = 120;

Mix0 = mix2mix(genmixe(ncom), 21);     % initial mixture
Mix  = Mix0;

DATA = [DATA; zeros(1, ndat)];         % added data channel
Fac0 = facarx(3, [ 0; 1]);             % auxiliary factor feeded by mixll

echo off
threshold = 0.005;
beta = 0.7;
k=0;

for rep = 1:100  % ====================================
    mixsimul(Sim, ndat);
    Mix   = Mix0;
    Fac   = Fac0;
    mixll = 0;

for TIME  = 1:ndat % -------------------------------------
    Mix   = mixestimp(Mix, 1);           % step of mixture update
    mixll = Mix.states.mixll;
    [Fac,Q]  = stopstac(Fac, [mixll, 1] );
    if Q<threshold, break; end;
end
TIMEs(rep) = TIME;

[Cl,Cu,Chat,flag,Q]=credits(TIMEs,beta,threshold);
    Cls(rep) = Cl; Cus(rep) = Cu; Chats(rep)=Chat;
    Qs(rep)  = Q;
    if Q<threshold & k==0, k=rep; break;  end
end

sub = 120;
LegendSize = 14;

sub=sub+1; subplot(sub);
plot(TIMEs,'o');
hold on
plot(TIMEs,':');
H=legend('Stopping time');
set(H, 'fontSize', LegendSize); 
grid on
xlabel('realizations');
ylabel('time');
drawnow

rep                                    % number of repetions
[Cl, Chat, Cu]                         % final credibility interval

if 1
sub=sub+1; subplot(sub);
plot(Qs,'o'); hold on; plot(Qs,':');
ax = axis; ax(4) = 0.1; axis(ax);
len = length(Qs);
hold on
plot([k k],[0 0.1]);
plot([1 len], [0.005 0.005], ':');
%plot([1 len], [0.01 0.01],   '.-');
%plot([1 len], [0.005 0.005], ':');
H=legend('Q', 'threshold','stop');


set(H, 'fontSize', LegendSize); 
xlabel('realizations');
drawnow
end

if 0
sub=sub+1; subplot(sub);
plot(Chats,'-'); hold on;
plot(Cls  ,':');
plot(Cus  ,'-.');
legend('Chat', 'Cls', 'Cus');
title('Estimation of credibility interval')
%plot(Chats, '-.'); plot(Cls  , '-.'); plot(Cus  , '-.');
ax = axis; ax(3)=50; axis(ax);
xlabel('time');
end

plt('fig5')