% zinititer.tex
% STOPPING RULES IN INITIALIZATION 
%
% Design : P. Nedoma
% Updated: DECEMBER 2004
% Projects : GACR 102/03/0049, AVCR S1075351, 1ET100750401, Edukalibre
%


prodini
echo off
idef = [];



results = [];

while 1 % ==============================================
if isempty(idef)

nchn = 2;                             % number of channels     
ncom = 10;                            % number of components
diac = 0.05;                          % diagonal of covar. matrix

ndat = 500;                           % sample size 
seed = 123;                           % seed of random generator

niter = 10;                           % No. of iterations
ncomi = 4; 
opt   = 'no';
niteri=10;
end

clc
fprintf('STOPPING RULES IN INITIALIZATION \n');
fprintf('--- System ------------------------------------\n');
fprintf('number of components   ->   ncom  = %i;\n',       ncom);
fprintf('diagonal of noise cov. ->   diac  = %g;\n',       diac);
disp(' ');
fprintf('---  Data -------------------------------------\n');
fprintf('size                   ->   ndat  = %i;\n',       ndat);
fprintf('seed                   ->   seed  = %i;\n',       seed);
disp(' ');
fprintf('---  Initialization --------------------------------\n');
fprintf('No. of initial components  ->   ncomi = %i;\n',     ncomi);
fprintf('number of iterations   ->   niter = %i;\n',     niter);

fprintf('\n... estimation in initialization ...................\n');
fprintf('iterative estimation   ->   opt   = ''%s'';  (p | q | b | f | Q | P)\n', opt); 
fprintf('number of iterations   ->   niteri = %i;\n', niteri);

dial1;

if opt(1)=='n', OPT = [];
else
   OPT = [opt,'n',int2str(niteri)]; 
end


cove = ltdl([diac, 0.1*diac; 0.1*diac diac]);

if seed, randn('seed',seed); rand('seed', seed); end

Sim  = statsim(ndat, ncom, cove);      % build static mixture


sub  = 230;
LegendSize=12;

clf; figure(1);
sub  = sub + 1; subplot(sub);
[x,y,z] = mixgrid(Sim); contour(x,y,z,15); grid on
H=legend('Simulator'); 
set(H, 'fontSize', LegendSize); grid on
drawnow

% ----------------------------------------------------------

Mix0 = genmixe(ncomi);
sub  = sub + 1; subplot(sub);
[x,y,z] = mixgrid(Mix0); contour(x,y,z,15); grid on
H=legend('Initital'); 
set(H, 'fontSize', LegendSize); grid on
drawnow


disp('initialization in progress ...');
PLOTSUB=230;
PLOTNO=3;
DEBUG=1;

Mix   = mixinit(Mix0, 1, ndat, niter, OPT); % mixture initialization

s=2*sqrt(diac);
setaxis([231, 233:236], [[-1-s  1+s], [-1-s  1+s] ])

ep = relep(Mix,1,1);

hold on
H=legend(sprintf('ncom =  %i', length(Mix.dfcs)),...
sprintf('ep = %g ',ep)  );
drawnow

plt('zinititer_');
dial2;
end % ====================================