 % case study: stoping rules
%
% Design : P. Nedoma
% Updated: October 2003
% Project: GA CR 102/03/0049, AV CR S1075351, S1075102, DESIGNER
prodini                                % startup routine
echo off
idef = [];
while 1 % ==============================================
if isempty(idef)
ndat = 500;                          % sample size       
ncom = 4;                            % sample size
dia  = 0.1;
seed = 123;                           % seed of random generator
threshold = 0.0025;
end

clc
fprintf('\n Case study: stopping rules setup\n');
fprintf('--- system ------------------------------------\n');
fprintf('number of components   ->   ncom  = %i;\n',       ncom);
fprintf('diagonal of noise cov. ->   dia   = %g;\n',       dia);
fprintf('--- data sample--------------------------------\n');
fprintf('size                   ->   ndat  = %i;\n',       ndat);
fprintf('seed                   ->   seed  = %i;\n',       seed);
fprintf('\n--- processing ------------------------------------\n');
fprintf('threshold   ->   threshold = %i;\n',     threshold);
dial1;
                                       % size of data sample
cove = ltdl([dia 0.1*dia ;0.1*dia dia]);     % common component noise variance
if seed, randn('seed',seed);rand('seed',seed); end
Sim  = statsim(ndat, ncom, cove);      % build static mixture

sub = 220;
LegendSize = 12;
clf; figure(1);
sub=sub+1; subplot(sub);
plot(DATA(1,:),DATA(2,:),'.');
hold on
statplot(Sim, '--');
H=legend('Clusters', 'centers', 'components');
set(H, 'fontSize', LegendSize); 
xlabel('data 1'); ylabel('data 2');
grid on
drawnow


Mix0 = mix2mix(genmixe(ncom), 21);     % initial mixture
Mix  = Mix0;
Fac  = facarx(1, [ 0; 1]);             % auxiliary factor feeded by mixll


echo off

for TIME = 1:ndat
    Mix   = mixestimp(Mix, 1);           % step of mixture update
    mixll = Mix.states.mixll; % current value of mixll
mixll=exp(mixll);
    mixlls(TIME) = mixll;
    [Fac,Q] = stopstac(Fac, [mixll, 1] );
    Qs(TIME) = Q;
    if Q<threshold, break; end
end

KONEC=TIME;

sub=sub+1; subplot(sub);
linplot(Mix);
H=legend('Estimated mixture');
set(H, 'fontSize', LegendSize); 
grid on
xlabel('data 1'); ylabel('data 2');
drawnow
setaxis(221:222);

sub=sub+1; subplot(sub);
plot(mixlls);
ax = axis; ax(1)=0; ax(2)=KONEC; axis(ax);
grid on
xlabel('time');
H=legend('Data pdf');
set(H, 'fontSize', LegendSize); 

sub=sub+1; subplot(sub);
plot(Qs); %hold on; plot(Qs,':')
ax = axis; ax(1)=0; ax(2)=KONEC;  ax(4)=0.2;    axis(ax);         % ax(4) = 0.1; axis(ax)

hold on
plot([1 KONEC], [threshold threshold], ':');
%plot([1 len], [0.01 0.01], ':');
%plot([1 len], [0.02 0.02], ':');
%plot([1 len], [0.03 0.03], ':'); 

ax = axis; ax(1)=0; ax(2)=KONEC; axis(ax);
xlabel('time');
H=legend('Q', 'threshold');
set(H, 'fontSize', LegendSize); 


drawnow

%disp('EDIT'); pause; print -depsc zstop2
plt('zstop2');


dial2;
 

end 

